Added a patch from Joshua Kinard <kumba@gentoo.org> to clean up the Pegasos hacks...
[genkernel.git] / genkernel
index e4f5dfe9004db79adde1a02d5fde0d317a38713f..bcc8fc519bcb17a769b9afd3d7e1e1655ea899fc 100755 (executable)
--- a/genkernel
+++ b/genkernel
@@ -1,29 +1,48 @@
 #!/bin/bash
-# Genkernel v3
 
 PATH="/bin:/usr/bin:/sbin:/usr/sbin"
-GK_V='3.3.11_pre3'
+GK_V='3.4.9_pre7'
 
+# Set the default for TMPDIR.  May be modified by genkernel.conf or the
+# --tempdir command line option.
 TMPDIR='/var/tmp/genkernel'
-TODEBUGCACHE=1 # Until an error occurs or DEBUGFILE is fully qualified.
+
+TODEBUGCACHE=1 # Until an error occurs or LOGFILE is fully qualified.
 
 small_die() {
   echo $1
   exit 1
 }
 
-source /etc/genkernel.conf || small_die "Could not read /etc/genkernel.conf"
-source ${GK_BIN}/gen_funcs.sh || small_die "Could not read ${GK_BIN}/gen_funcs.sh"
-source ${GK_BIN}/gen_cmdline.sh || gen_die "Could not read ${GK_BIN}/gen_cmdline.sh"
-source ${GK_BIN}/gen_arch.sh || gen_die "Could not read ${GK_BIN}/gen_arch.sh"
-source ${GK_BIN}/gen_determineargs.sh || gen_die "Could not read ${GK_BIN}/gen_determineargs.sh"
-source ${GK_BIN}/gen_compile.sh || gen_die "Could not read ${GK_BIN}/gen_compile.sh"
-source ${GK_BIN}/gen_configkernel.sh || gen_die "Could not read ${GK_BIN}/gen_configkernel.sh"
-source ${GK_BIN}/gen_initrd.sh || gen_die "Could not read ${GK_BIN}/gen_initrd.sh"
-source ${GK_BIN}/gen_initramfs.sh || gen_die "Could not read ${GK_BIN}/gen_initramfs.sh"
-source ${GK_BIN}/gen_moddeps.sh || gen_die "Could not read ${GK_BIN}/gen_moddeps.sh"
-source ${GK_BIN}/gen_package.sh || gen_die "Could not read ${GK_BIN}/gen_package.sh"
-source ${GK_BIN}/gen_bootloader.sh || gen_die "Could not read ${GK_BIN}/gen_bootloader.sh"
+parse_opt() {
+       case "$1" in
+               *\=*)
+                       echo "$1" | cut -f2- -d=
+               ;;
+       esac
+}
+
+# We don't know where our config is, so we check for it, and default to using
+# /etc/genkernel.conf if nobody has specified one.
+case "$*" in
+       --config=*)
+               CMD_GK_CONFIG=`parse_opt "$*"`
+       ;;
+esac
+
+source ${CMD_GK_CONFIG:-/etc/genkernel.conf} || small_die "Could not read /etc/genkernel.conf"
+
+source ${GK_SHARE}/gen_funcs.sh || small_die "Could not read ${GK_SHARE}/gen_funcs.sh"
+source ${GK_SHARE}/gen_cmdline.sh || gen_die "Could not read ${GK_SHARE}/gen_cmdline.sh"
+source ${GK_SHARE}/gen_arch.sh || gen_die "Could not read ${GK_SHARE}/gen_arch.sh"
+source ${GK_SHARE}/gen_determineargs.sh || gen_die "Could not read ${GK_SHARE}/gen_determineargs.sh"
+source ${GK_SHARE}/gen_compile.sh || gen_die "Could not read ${GK_SHARE}/gen_compile.sh"
+source ${GK_SHARE}/gen_configkernel.sh || gen_die "Could not read ${GK_SHARE}/gen_configkernel.sh"
+source ${GK_SHARE}/gen_initrd.sh || gen_die "Could not read ${GK_SHARE}/gen_initrd.sh"
+source ${GK_SHARE}/gen_initramfs.sh || gen_die "Could not read ${GK_SHARE}/gen_initramfs.sh"
+source ${GK_SHARE}/gen_moddeps.sh || gen_die "Could not read ${GK_SHARE}/gen_moddeps.sh"
+source ${GK_SHARE}/gen_package.sh || gen_die "Could not read ${GK_SHARE}/gen_package.sh"
+source ${GK_SHARE}/gen_bootloader.sh || gen_die "Could not read ${GK_SHARE}/gen_bootloader.sh"
 
 TEMP=${TMPDIR}/$RANDOM.$RANDOM.$RANDOM.$$
 
@@ -46,10 +65,6 @@ cleanup(){
            CLEAR_CACHE_DIR='yes'
            setup_cache_dir
            echo
-           print_info 1 "CACHE_CPIO_DIR: ${CACHE_CPIO_DIR}"
-           CLEAR_CPIO_CACHE='yes'
-           clear_cpio_dir
-           echo
            print_info 1 "TMPDIR: ${TMPDIR}"
            clear_tmpdir
            fi
@@ -127,27 +142,29 @@ then
        fi
 fi
 
-# Check /boot is mounted
+# Check BOOTDIR is mounted
 if isTrue ${CMD_NOINSTALL}
 then
        isTrue ${MOUNTBOOT} && print_info 2 'Skipping automatic mount of boot'
 else
-       if ! egrep -q ' /boot ' /proc/mounts
+       [[ -d ${BOOTDIR} ]] || gen_die "${BOOTDIR} is not a directory"
+       
+       if ! egrep -q "[[:space:]]${BOOTDIR}[[:space:]]" /proc/mounts
        then
-               if egrep -q '^[^#].+    /boot   ' /etc/fstab
+               if egrep -q "^[^#].+[[:space:]]${BOOTDIR}[[:space:]]" /etc/fstab
                then
                        if isTrue ${MOUNTBOOT}
                        then
-                               if ! mount /boot
+                               if ! mount ${BOOTDIR}
                                then
-                                       print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to mount /boot!"
+                                       print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to mount ${BOOTDIR}!"
                                        echo
                                else
-                                       print_info 1 'mount: /boot mounted successfully!'
+                                       print_info 1 "mount: ${BOOTDIR} mounted successfully!"
                                fi
                        else
-                               print_warning 1 "${BOLD}WARNING${NORMAL}: No mounted /boot partition detected!"
-                               print_warning 1 '         Run ``mount /boot`` to mount it!'
+                               print_warning 1 "${BOLD}WARNING${NORMAL}: No mounted ${BOOTDIR} partition detected!"
+                               print_warning 1 "         Run ``mount ${BOOTDIR}`` to mount it!"
                                echo
                        fi
                fi
@@ -155,12 +172,12 @@ else
        then
                if isTrue ${MOUNTBOOT}
                then
-                       if ! mount -o remount,rw /boot
+                       if ! mount -o remount,rw ${BOOTDIR}
                        then
-                               print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to remount /boot RW!"
+                               print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to remount ${BOOTDIR} RW!"
                                echo
                        else
-                               print_info 1 "mount: /boot remounted read/write successfully!"
+                               print_info 1 "mount: ${BOOTDIR} remounted read/write successfully!"
                                BOOTRW=1
                        fi
                fi
@@ -214,7 +231,7 @@ then
 
        # Compile kernel; If using --genzimage, or building a mips kernel, skip compile
        # till after initrd/initramfs is done
-       [ "${GENERATE_Z_IMAGE}" = '' -a "${MIPS_EMBEDDED_IMAGE}" = '' ] && compile_kernel
+       [ "${ENABLE_PEGASOS_HACKS}" != 'yes' -a ${BUILD_INITRAMFS} -eq 0 ] && compile_kernel
 
        # Compile modules
        if [ ${BUILD_MODULES} -eq 1 -a ${BUILD_STATIC} -eq 0 ]
@@ -230,7 +247,7 @@ then
        fi
        if [ "${KERNCACHE}" != "" ]
        then
-               if [ "${GENERATE_Z_IMAGE}" = '' -a "${MIPS_EMBEDDED_IMAGE}" = '' ]
+               if [ "${ENABLE_PEGASOS_HACKS}" != 'yes' -a ${BUILD_INITRAMFS} -eq 0 ]
                then
                        gen_kerncache
                fi
@@ -272,7 +289,7 @@ then
        then
                echo
                echo
-               eval ${CMD_CALLBACK} | tee -a ${DEBUGFILE}
+               eval ${CMD_CALLBACK} | tee -a ${LOGFILE}
                CMD_STATUS="${PIPESTATUS[0]}"
                echo
                print_info 1 "<<< Callback exit status: ${CMD_STATUS}"
@@ -287,30 +304,14 @@ fi
 
 if [ "${BUILD_INITRD}" -eq '1' ]
 then
-       # Only compile insmod if we're installing modules onto the initrd
-       if [ "${NOINITRDMODULES}" = '' ]
-       then
-               if [ "${KERN_24}" != '1' ]
-               then
-                       # Compile module-init-tools
-                       [ ${BUILD_STATIC} -eq 0 ] && compile_module_init_tools
-               else
-                       [ ${BUILD_STATIC} -eq 0 ] && compile_modutils
-               fi
-       fi
-       
        [ "${DISKLABEL}" -eq '1' ] && compile_e2fsprogs
 
-       if [ "${KERN_24}" != '1' -a "${UDEV}" -eq '1' ] 
+       if [ "${KERN_24}" -eq '1' ] 
        then
-               compile_udev 
-       else
-               DEVFS=1
-               UDEV=0
                compile_devfsd
        fi
 
-       if [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
+       if [ "${KERN_24}" != '1' ]
        then
            if [ "${BUSYBOX}" -eq '1' ]
            then
@@ -330,7 +331,7 @@ else
 fi
 
 # Pegasos fix
-if [ "${GENERATE_Z_IMAGE}" != '' -o "${MIPS_EMBEDDED_IMAGE}" != '' ]
+if [ "${ENABLE_PEGASOS_HACKS}" = 'yes' -o ${BUILD_INITRAMFS} -eq 1 ]
 then
        # Compile kernel, intergrating the initrd into it for Pegasos & mips
        compile_kernel
@@ -360,7 +361,7 @@ then
                print_info 1 ''
                print_info 1 '    Where $ROOT is the device node for your root partition as the'
                print_info 1 '    one specified in /etc/fstab'
-       elif [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
+       elif [ "${KERN_24}" != '1' ]
        then
                print_info 1 '    real_root=/dev/$ROOT'
                print_info 1 ''
@@ -390,55 +391,16 @@ then
        echo
        print_info 1 'WARNING... WARNING... WARNING...'
        print_info 1 'Additional kernel cmdline arguments that *may* be required to boot properly...'
-       [ "${GENSPLASH}" -eq '1' ] && print_info 1 "add \"vga=791 splash=silent,theme:${GENSPLASH_THEME} CONSOLE=/dev/tty1 quiet\" if you use a gensplash framebuffer ]"
-       [ "${BOOTSPLASH}" -eq '1' ] && print_info 1 'add "vga=791 splash=silent" if you use a bootsplash framebuffer'
-       [ "${LVM2}" -eq '1' ] && print_info 1 'add "dolvm2" for lvm2 support'
-       [ "${EVMS2}" -eq '1' ] && print_info 1 'add "doevms2" for evms support'
+       [ "${SPLASH}" -eq '1' ] && print_info 1 "add \"vga=791 splash=silent,theme:${SPLASH_THEME} console=tty1 quiet\" if you use a splash framebuffer ]"
+       [ "${LVM}" -eq '1' ] && print_info 1 'add "dolvm" for lvm support'
+       [ "${EVMS}" -eq '1' ] && print_info 1 'add "doevms" for evms support'
        [ "${DMRAID}" -eq '1' ] && print_info 1 'add "dodmraid" for dmraid support'
        [ "${DMRAID}" -eq '1' ] && print_info 1 '       or "dodmraid=<additional options>"'
        [ "${UNIONFS}" -eq '1' ] && print_info 1 'add "unionfs" for unionfs support'
        [ "${UNIONFS}" -eq '1' ] && print_info 1 '      or "unionfs=<block_device>"'
 fi
 
-if [ "${CMD_NOINSTALL}" != '1' -a "${SYMLINK}" = '1' ]
-then 
-    echo
-    print_info 1 'Creating symlinks'
-    
-    
-    print_info 1 '         creating kernel name symlink!'
-    if [ -e /boot/kernel-${KNAME}-${ARCH}-${KV} ]
-    then
-       /bin/rm /boot/kernel
-        ln -s /boot/kernel-${KNAME}-${ARCH}-${KV} /boot/kernel
-        ret=$?
-        [ ${ret} = '1' ] && print_error 1 'kernel link failed'
-    fi
-    
-    if [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
-    then
-       print_info 1 '      creating initramfs name symlink!'
-       if [ -e /boot/initramfs-${KNAME}-${ARCH}-${KV} ]
-       then
-           /bin/rm /boot/initramfs
-           ln -s /boot/initramfs-${KNAME}-${ARCH}-${KV} /boot/initramfs
-           ret=$?
-           [ ${ret} = '1' ] && print_error 1 'initramfs link failed'
-       fi
-    else
-       print_info 1 '      creating initrd name symlink!'
-       if [ -e /boot/initrd-${KNAME}-${ARCH}-${KV} ]
-       then
-           /bin/rm /boot/initrd
-           ln -s /boot/initrd-${KNAME}-${ARCH}-${KV} /boot/initrd
-           ret=$?
-           [ ${ret} = '1' ] && print_error 1 'initrd link failed'
-       fi
-    fi
-fi
-
-
-[ "${BOOTRW}" != '' ] && mount -o remount,ro /boot
+[ "${BOOTRW}" != '' ] && mount -o remount,ro ${BOOTDIR}
 
 echo
 print_info 1 'Do NOT report kernel bugs as genkernel bugs unless your bug'